import React, { useMemo } from 'react'
import { View } from '@tarojs/components'
import { Image } from '@antmjs/vantui'
import './style.less'

export default (props) => {
  const { info, num } = props
  const { avatar, nickname, score } = info || {}

  const size = 64

  const avatarStyle = useMemo(() => {
    return {
      width: `${size}px`
    }
  }, [size])

  return (
    <View className='topic-item flex-box'>
      <View className='topic-item-num flex-box-item-fixed'>{num}</View>
      <View className='flex-box topic-item-border flex-box-item'>
        <View className='flex-box-item-fixed topic-item-avatar' style={avatarStyle}>
          <Image src={avatar} width={size} height={size} round></Image>
        </View>
        <View className='flex-box-item topic-item-nickname'>{nickname}</View>
        <View className='flex-box-item topic-item-score'>{score}</View>
      </View>
    </View>
  )
}
