import { View } from '@tarojs/components'
import React, { useMemo, useState } from 'react'
import Taro from '@tarojs/taro'
import Topic1 from './components/Topic1'
import TopicItem from './components/TopicItem'

import './style.less'

const testData = [
  {
    nickname: 'test1',
    score: 234234,
  },
  {
    nickname: 'test2',
    score: 234234,
  },
  {
    nickname: 'test3',
    score: 234234,
  },
  {
    nickname: 'test4',
    score: 234234,
  },
  {
    nickname: 'test5',
    score: 234234,
  },
  {
    nickname: 'test6',
    score: 234234,
  },
  {
    nickname: 'test7',
    score: 234234,
  },
  {
    nickname: 'test8',
    score: 234234,
  },
  {
    nickname: 'test9',
    score: 234234,
  },
  {
    nickname: 'test10',
    score: 234234,
  },
]

export default (props) => {

  const [list, setList] = useState(testData)
  const menuBtnBounding = useMemo(() => Taro.getMenuButtonBoundingClientRect(), [])
  const style = useMemo(() => {
    const top = menuBtnBounding.height + menuBtnBounding.top

    return {
      paddingTop: `${top}px`
    }
  }, [menuBtnBounding.height, menuBtnBounding.top])

  const [first, leftData] = useMemo(() => {
    const [f, ...l] =  list || []
    return [f, l]
  }, [list])

  return (
    <View className='page-wrapper page-toplist' style={style}>
      <Topic1 info={first} />
      <View>
        {
          leftData.map((item, inx) => (
            <TopicItem key={inx} num={inx+2} info={item} />
          ))
        }
      </View>
    </View>
  )
}
