
export default function Shake() {
  const shakeData = {
    shakeSpeed: 110, //设置阈值,越小越灵敏
    // shakeStep: 2000, //摇一摇成功后间隔
    lastTime: 0, //此变量用来记录上次摇动的时间
    x: 0,
    y: 0,
    z: 0,
    lastX: 0,
    lastY: 0,
    lastZ: 0,
  }

  function onShake(acceleration, next) {
    //记录当前时间
    const nowTime = new Date().getTime();

    //如果这次摇的时间距离上次摇的时间有一定间隔 才执行
    const diff = 20;
    if (nowTime - shakeData.lastTime > diff) {
     var diffTime = nowTime - shakeData.lastTime; //记录时间段
     shakeData.lastTime = nowTime; //记录本次摇动时间，为下次计算摇动时间做准备
     shakeData.x = acceleration.x; //获取 x 轴数值，x 轴为垂直于北轴，向东为正
     shakeData.y = acceleration.y; //获取 y 轴数值，y 轴向正北为正
     shakeData.z = acceleration.z; //获取 z 轴数值，z 轴垂直于地面，向上为正
     //计算 公式的意思是 单位时间内运动的路程，即为我们想要的速度
     var speed = Math.abs(shakeData.x + shakeData.y + shakeData.z - shakeData.lastX - shakeData.lastY - shakeData.lastZ) / diffTime * 10000;
     //console.log(speed)
     if (speed > shakeData.shakeSpeed) { //如果计算出来的速度超过了阈值，那么就算作用户成功摇一摇
        next();
      }

     shakeData.lastX = shakeData.x; //赋值，为下一次计算做准备
     shakeData.lastY = shakeData.y; //赋值，为下一次计算做准备
     shakeData.lastZ = shakeData.z; //赋值，为下一次计算做准备
    }
  }

  return {
    onShake
  }
}

